<?php
/**
 * Copyright (c) 2019 Mobicommerce (https://www.mobicommerce.net)
 * @website    www.mobicommerce.net
 * @package    Mobicommerce_CustomEmailUrl Custom Email Url
 * @author     Mobicommerce @13
 */

namespace Mobicommerce\CustomEmailUrl\Plugin\Framework\Mail;
use Magento\Store\Model\ScopeInterface;

class CustomEmailUrl
{
    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $storeManager;

    /**
     * Scope config
     *
     * @var \Magento\Framework\App\Config\ScopeConfigInterface
     */
    protected $scopeConfig;

    /**
     * @var \Magento\Framework\UrlInterface
     */
    private $urlModel;

    const XML_PATH_CUSTOME_EMAIL_ENABLE = 'mobi_basic/headless/is_enable';
    const XML_PATH_CUSTOM_EMAIL_URL = 'mobi_basic/headless/frontend_url';
    const XML_PATH_CUSTOME_MAGENTO_URL = 'mobi_basic/headless/magento_url';

    /**
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     * @param \Magento\Framework\UrlInterface $urlModel
     *
     * @SuppressWarnings(PHPMD.ExcessiveParameterList)
     */
    public function __construct(        
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\UrlInterface $urlModel,
        \Mobicommerce\Mobiapp\Helper\Config $mobiconfig,
        array $data = []
    ) {
        $this->storeManager = $storeManager;
        $this->scopeConfig = $scopeConfig;
        $this->mobiconfig = $mobiconfig;
        $this->urlModel = $urlModel;
    }

    public function getCustomEmailUrl()
    {
       /* $customEmailUrl = $this->scopeConfig->getValue(
            self::XML_PATH_CUSTOM_EMAIL_URL,
            ScopeInterface::SCOPE_STORE);*/
        $customEmailUrl = $this->mobiconfig->getStoreUrl();
        return $customEmailUrl;
    }

    private function getMagentoUrl()
    {
        return $this->scopeConfig->getValue(
            self::XML_PATH_CUSTOME_MAGENTO_URL,
            ScopeInterface::SCOPE_STORE);
        
    }

    public function isEnable()
    {
        $is_enable = $this->scopeConfig->getValue(
            self::XML_PATH_CUSTOME_EMAIL_ENABLE,
            ScopeInterface::SCOPE_STORE);
        if($is_enable)
        {
            return true;
        }else
        {
            return false;
        }    
        return $is_enable;
    }
    
    public function afterGetUrl(\Magento\Email\Model\AbstractTemplate $subject,         
        $route = '',
        $params = []) 
    {
        /*
        $store = $this->storeManager->getStore();
        $url = $this->urlModel->setScope($store);
        if ($this->storeManager->getStore()->getId() != $store->getId()) {
            $params['_scope_to_url'] = true;
        }
        if($this->isEnable())
        {
            $customUrl = $this->getCustomEmailUrl();
            $customUrlParameter = $url->getUrl($route, $params);
            $emailUrl = str_replace($url->getBaseUrl(), $customUrl.'/', $customUrlParameter);
        }else
        {
            $emailUrl = $url->getUrl($route, $params);
        }*/
        if($this->isEnable())
        {
            $baseUrl = trim($this->getMagentoUrl(),"/");
            $customUrl = trim($this->getCustomEmailUrl(),"/");
            $route = str_replace($baseUrl, $customUrl, $route);
        }
        



        return $route;
    }

    public function afterGetProcessedTemplate(\Magento\Email\Model\AbstractTemplate $subject,         
        $result,
        $variables = []) 
    {
        $store = $this->storeManager->getStore();
        //$url = $this->urlModel->setScope($store);
        
       // echo  $baseUrl = trim($url->getBaseUrl()); exit; 
        if($this->isEnable())
        {
            $baseUrl = trim($this->getMagentoUrl(),"/");
            $customUrl = trim($this->getCustomEmailUrl(),"/");
            $replaceList["href = '".$baseUrl] = "href = '".$customUrl;
            $replaceList["href='".$baseUrl] = "href='".$customUrl;
            $replaceList["href ='".$baseUrl] = "href ='".$customUrl;
            $replaceList["href= '".$baseUrl] = "href= '".$customUrl;
            
            $replaceList['href = "'.$baseUrl] = 'href = "'.$customUrl;
            $replaceList['href="'.$baseUrl] = 'href="'.$customUrl;
            $replaceList['href ="'.$baseUrl] = 'href ="'.$customUrl;
            $replaceList['href= "'.$baseUrl] = 'href= "'.$customUrl;

            //$customUrl = $this->getCustomEmailUrl();
            foreach($replaceList as $baseU=>$customU)
            {
                $result = str_replace($baseU, $customU, $result);
            }
            //echo $result; exit;
        }
        return $result;
    }
}
