<?php
declare(strict_types=1);

namespace Mobicommerce\CustomerSpecificCoupon\Plugin;


use Magento\SalesRule\Model\Utility;
use Magento\Framework\Stdlib\DateTime\TimezoneInterface;

class ValidateCustomerSpecificCoupon
{
    /**
     * @var TimezoneInterface
     */
    protected $customerSession;

    /**
     * @param TimezoneInterface $timezoneInterface
     */
    public function __construct(
        \Magento\Customer\Model\Session $customerSession
    ) {
        $this->customerSession = $customerSession;
    }

    /**
     * after the canProcessRule, Check if salesRule can be applied for the day of the week
     *
     * @param  \Magento\SalesRule\Model\Utility $subject
     * @param  boolean $result
     * @param  \Magento\SalesRule\Model\Rule $rule
     * @param  \Magento\Quote\Model\Quote\Address $address
     * @return boolean
     */
    public function afterCanProcessRule(Utility $subject, bool $result, $rule, $address)
    {
        if ($result) {

            /*
            $writer = new \Zend_Log_Writer_Stream(BP . '/var/log/custom.log');
            $logger = new \Zend_Log();
            $logger->addWriter($writer);
            $logger->info("Current Customer ID: " .  $this->customerSession->getCustomerId() . " - Rule Customer ID: " . $rule->getMobiCustomerId()); 
            */  
                    
            // by pass if no customer id is there in rule. consider it normal coupon
            if((int)$rule->getMobiCustomerId() > 0){
                // check current customer id is same as rule id, if yes allow else return false. in case of guest also it will return false
                if($this->customerSession->getCustomerId() == $rule->getMobiCustomerId()){
                    $result = true;

                } else{
                    $result = false;       
                }
            } else {
              $result = true; 
            }
            
            return $result;
        }
    }
}