<?php
namespace Mobicommerce\CustomerSpecificCoupon\Setup;

use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Customer\Model\Customer;
use Magento\Customer\Setup\CustomerSetupFactory;

class InstallData implements InstallDataInterface
{
 
    private $customerSetupFactory;
 
    /**
     * Constructor
     *
     * @param \Magento\Customer\Setup\CustomerSetupFactory $customerSetupFactory
     */
    public function __construct(
        CustomerSetupFactory $customerSetupFactory
    ) {
        $this->customerSetupFactory = $customerSetupFactory;
    }
 
    /**
     * {@inheritdoc}
     */
    public function install(
        ModuleDataSetupInterface $setup,
        ModuleContextInterface $context
    ) {
        $installer = $setup;
 
        $installer->startSetup();
 
        $installer->getConnection()->addColumn(
            $installer->getTable('salesrule'),
            'mobi_customer_id',
            [
                'type' => \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                'visible'  => true,
                'nullable' => true,
                'default' => 0,
                'comment' => 'Customer Id for Customer specific discount coupon'
            ]
        );

        $installer->getConnection()->addColumn(
            $installer->getTable('salesrule'),
            'mobi_remark',
            [
                'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                'visible'  => true,
                'nullable' => true,
                'default' => "",
                'comment' => 'A Remark field to keep comments from admin team about the membership coupon'
            ]
        );        
 
    }
}