<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_GeoFencing
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\GeoFencing\Block\Adminhtml\Order\View;

use Magento\Framework\Exception\LocalizedException;
use Magento\Sales\Block\Adminhtml\Order\AbstractOrder;

class ShippingAddress extends AbstractOrder
{
    /**
     * Get gmap url
     *
     * @return string
     * @throws LocalizedException
     */
    public function getGmapUrl()
    {
        return implode(
            '',
            [
                'https://www.google.com/maps/place/',
                $this->getOrder()->getShippingAddress()->getData('mc_latitude'),
                '+',
                $this->getOrder()->getShippingAddress()->getData('mc_longitude'),
            ]
        );
    }
}
