<?php

namespace Mobicommerce\GeoFencing\Controller\Adminhtml\Index;

use Magento\Backend\App\Action;
use Magento\Framework\View\Result\PageFactory;

class Index extends Action
{
    public const ADMIN_RESOURCE = 'Mobicommerce_GeoFencing::configure';

    /**
     * @var bool|PageFactory
     */
    protected $resultPageFactory = false;

    /**
     * Constructor
     *
     * @param Action\Context $context
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        Action\Context $context,
        PageFactory $resultPageFactory
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
    }

    /**
     * Controller
     *
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $resultPage = $this->resultPageFactory->create();
        $resultPage->setActiveMenu('Mobicommerce_GeoFencing::configure');
        $resultPage->getConfig()->getTitle()->prepend((__('Website GEO Fencing')));

        return $resultPage;
    }
}
