<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Mobicommerce\GeoFencing\Model\Resolver;

use Magento\Customer\Model\Customer;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\GraphQl\Schema\Type\ResolveInfo;
use Magento\Framework\GraphQl\Config\Element\Field;
use Magento\Framework\GraphQl\Query\ResolverInterface;


use Mobicommerce\GeoFencing\Helper\Data as Helper;
use Magento\Store\Model\StoreManagerInterface;
use Magento\Customer\Api\AddressRepositoryInterface;
/**
 * Customers addresses field resolver
 */
class ValidateAddress implements ResolverInterface
{
    
    /**
     * @param ExtractCustomerAddressData $extractCustomerAddressData
     */
    public function __construct(
        Helper $helper,
        StoreManagerInterface $storeManager
      
       
    ) {
        $this->helper = $helper;
        $this->storeManager = $storeManager;
       
    }

    /**
     * @inheritdoc
     */
    public function resolve(
        Field $field,
        $context,
        ResolveInfo $info,
        array $value = null,
        array $args = null
    ) {
        if (!isset($args['lat']) || !isset($args['long'])) {
            throw new LocalizedException(__('Please specify lat,long'));
        }
                // --- get all website ids for LatLong
                $websiteId = $this->helper->getWebsiteIdFromLatLng($args['lat'], $args['long'], true);

                if(!is_array($websiteId)){
                    $websiteIds[]=$websiteId;
                }else{
                    $websiteIds=$websiteId;
                }
                //----current store is exist in supported websites list? 
                if (in_array($this->storeManager->getStore()->getWebsiteId(), $websiteIds)){
                    return['status'=>"true","message"=>"Valid address"];
                }else{
                    return['status'=>"false","message"=>"We are not provide delivery on the given location"];
                }        
    }
}
