<?php

namespace Mobicommerce\GeoWebsite\Setup;

use Magento\Customer\Model\Customer;
use Magento\Customer\Setup\CustomerSetupFactory;
use Magento\Eav\Model\Entity\Attribute\Set as AttributeSet;
use Magento\Eav\Model\Entity\Attribute\SetFactory as AttributeSetFactory;
use Magento\Eav\Setup\EavSetupFactory;

use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;

class RecurringData implements InstallDataInterface {
  /**
   * EAV setup factory
   *
   * @var EavSetupFactory
   */
  private $eavSetupFactory;

  /**
   * CustomerSetupFactory
   * @var CustomerSetupFactory
   */
  protected $customerSetupFactory;

  /**
   * $attributeSetFactory
   * @var AttributeSetFactory
   */
  private $attributeSetFactory;

  /**
   * Init
   *
   * @param EavSetupFactory $eavSetupFactory
   */
  public function __construct(
    EavSetupFactory $eavSetupFactory,
    CustomerSetupFactory $customerSetupFactory,
    AttributeSetFactory $attributeSetFactory,
    \Mobicommerce\Mobiapp\Helper\LanguageFile $langHelper
    
  ) {
    $this->eavSetupFactory = $eavSetupFactory;
    $this->customerSetupFactory = $customerSetupFactory;
    $this->attributeSetFactory = $attributeSetFactory;

    $this->langHelper = $langHelper;
    
  }

  /**
   * {@inheritdoc}
   */
  public function install(ModuleDataSetupInterface $setup, ModuleContextInterface $context) {
    $setup->startSetup();

    /** @var CustomerSetup $customerSetup */
        //echo "in file"; exit;
    $this->langHelper->copyLangFiles("Mobicommerce_GeoWebsite");
    
    
    $setup->endSetup();
  }
}
