<?php

namespace Mobicommerce\InappPayment\Block;

use Magento\Framework\View\Element\Template;
use Magento\Checkout\Model\Session as CheckoutSession;
use Magento\Framework\App\Config\ScopeConfigInterface as ScopeConfig;

class Checkout extends Template
{
    /**
     * @var CheckoutSession
     */
    private CheckoutSession $checkoutSession;

    /**
     * Constructor
     *
     * @param Template\Context $context
     * @param CheckoutSession $checkoutSession
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        CheckoutSession $checkoutSession,
        ScopeConfig $scopeConfig,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->checkoutSession = $checkoutSession;
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * Check weather session is set or not
     *
     * @return bool
     */
    public function isMobiInappPayment(): bool
    {
        return (bool) $this->checkoutSession->getMobiInAppPayment();
    }

    public function getSelectedPaymentMethods(){
        return $this->scopeConfig->getValue('mobi_basic/payment_settings/magento_payment_methods', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
    }

}
