<?php

namespace Mobicommerce\InappPayment\Block;

use Magento\Framework\View\Element\Template;
use Magento\Checkout\Model\Session as CheckoutSession;
use Magento\Framework\App\Config\ScopeConfigInterface as ScopeConfig;
use Magento\Cms\Block\Block as cmsBlock;

class Header extends Template
{
    /**
     * @var CheckoutSession
     */

    private cmsBlock $cmsblock;

    private ScopeConfig $scopeConfig;


    /**
     * Constructor
     *
     * @param Template\Context $context
     * @param CheckoutSession $checkoutSession
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        cmsBlock $cmsblock,
        ScopeConfig $scopeConfig,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->scopeConfig = $scopeConfig;
        $this->cmsblock = $cmsblock;

    }
    public function getCmsBlock($identifier)
        {
        $cmsblock = $this->cmsblock->setBlockId($identifier)->toHtml();
        return $cmsblock;
        }

    public function toHtml()
    {
        $headerBlockId = $this->scopeConfig->getValue('mobi_basic/payment_settings/mobi_header_block', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        if(empty($headerBlockId))
        {
            $headerBlockId = "mobicommerce-headless-header";
        }
        
        return $this->getCmsBlock($headerBlockId);
        
    }    
    
}
