<?php

namespace Mobicommerce\InappPayment\Controller\Checkout;

use Magento\Framework\App\ActionInterface;
use Magento\Framework\App\ResponseInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\Controller\Result\RawFactory;
use Magento\Framework\Controller\ResultInterface;

class Success implements ActionInterface
{
    /**
     * @var RawFactory
     */
    private RawFactory $rawFactory;

    /**
     * @var RequestInterface
     */
    private RequestInterface $request;

    /**
     * Constructor
     *
     * @param RawFactory $rawFactory
     * @param RequestInterface $request
     */
    public function __construct(
        RawFactory $rawFactory,
        RequestInterface $request
    ) {
        $this->rawFactory = $rawFactory;
        $this->request = $request;
    }

    /**
     * Prints raw order increment id for mobile app
     *
     * @return ResponseInterface|ResultInterface
     */
    public function execute()
    {
        $incrementId = $this->request->getParam('increment_id', false);

        $result = $this->rawFactory->create();
        $result->setContents($incrementId);
        return $result;
    }
}
