<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_InappPayment
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\InappPayment\Model\Source;

use Magento\Framework\Data\OptionSourceInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Payment\Helper\Data as paymentData;

class MagentoPaymentMethods implements OptionSourceInterface
{
    /**
     * StoreViewFirstLevelCategories constructor.
     *
     * @param Magento\Framework\App\RequestInterface $request
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param Magento\Catalog\Model\CategoryFactory $categoryFactory
     */
    public function __construct(
        RequestInterface $request,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        paymentData $paymentHelper
    ) {
        $this->request = $request;
        $this->storeManager = $storeManager;
        $this->paymentHelper = $paymentHelper;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result = [];
        $allPaymentMethods = $this->paymentHelper->getPaymentMethods();

        // payment methods list array
        $allPaymentMethodsArray = $this->paymentHelper->getPaymentMethodList();

        foreach($allPaymentMethodsArray as $key=>$value)
        {     
            //echo "<pre>$key"; print_r($value); exit;

                    $result[] = [
                        'value' => $key,
                        'label' => $value
                    ];  
        
        }    
        return $result;
    }
}
