<?php
namespace Mobicommerce\InappPayment\Observer;


use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\App\Config\ScopeConfigInterface as ScopeConfig;


class CustomLayout implements  ObserverInterface
{
 
    protected $_registry;

    protected $_request;

    protected $_checkoutSession;

    protected $scopeConfig;


    public function __construct(
        \Magento\Framework\App\RequestInterface $request,
        \Magento\Framework\Registry $registry,
        \Magento\Checkout\Model\Session $checkoutSession,
        ScopeConfig $scopeConfig
    )
    {       
        $this->_request = $request;
        $this->_registry = $registry;
        $this->_checkoutSession = $checkoutSession;
        $this->scopeConfig = $scopeConfig;
    }


    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        $action = $observer->getData('full_action_name');

        if ($action !== 'checkout_index_index') {
            return;
        }
        $request = $this->_request->getParams();
        $layout = $observer->getLayout();
        $enable = $this->scopeConfig->getValue(
            'mobi_advance/modules_features/mobi_inapppayment',
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
        if ($this->_checkoutSession->getMobiInAppPayment() && $enable) {
            $layout->getUpdate()->addHandle('checkout_index_index_custom');
        }
        return $this;
    }
}
