<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_GeoFencing
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\InappPayment\Plugin\Helper;

class StaticFiles
{
    /**
     * afterAddWebsiteData
     *
     * @param Subject $subject
     * @param Return $data
     */
    public function afterAddWebsiteData($subject, $data)
    {
        $mobiInAppPayment = $subject->getStoreConfig('mobi_advance/modules_features/mobi_inapppayment');

        $mc_inapppayment_is_default = $subject->getStoreConfig('mobi_basic/payment_settings/mobi_default_magento_payment_enable');

        $mc_inapppayment_is_methods = $subject->getStoreConfig('mobi_basic/payment_settings/magento_payment_methods');

        $data['mc_inapppayment'] = (empty($mobiInAppPayment)) ? '0' : $mobiInAppPayment;
        $data['mc_inapppayment_is_default'] = (empty($mc_inapppayment_is_default)) ? '0' : $mc_inapppayment_is_default;
        $data['mc_inapppayment_is_methods'] = (empty($mc_inapppayment_is_methods)) ? '0' : $mc_inapppayment_is_methods;

        return $data;
    }

    
}
