<?php

namespace Mobicommerce\InappPayment\Plugin\Magento\Checkout\Controller\Onepage;

use Magento\Framework\Controller\Result\Redirect;
use Magento\Framework\Controller\Result\RedirectFactory;
use Magento\Checkout\Model\Session as CheckoutSession;

class Failure
{
    /**
     * @var RedirectFactory
     */
    private RedirectFactory $redirectFactory;

    /**
     * @var CheckoutSession
     */
    private CheckoutSession $checkoutSession;

    /**
     * Constructor
     *
     * @param RedirectFactory $redirectFactory
     * @param CheckoutSession $checkoutSession
     */
    public function __construct(
        RedirectFactory $redirectFactory,
        CheckoutSession $checkoutSession,
         //added by Mobi PWA
         \Mobicommerce\Mobiapp\Helper\Config $mobiconfig,
         \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig

    ) {
        $this->redirectFactory = $redirectFactory;
        $this->checkoutSession = $checkoutSession;

        //added by Mobi PWA
        $this->mobiconfig = $mobiconfig;
        $this->scopeConfig = $scopeConfig;

    }

    public function getPWAUrl()
    {
        $PWAUrl = $this->mobiconfig->getStoreUrl();
        return $PWAUrl;
    }

    /**
     * Redirect to custom success page
     *
     * @param $subject
     * @param $result
     * @return Redirect|mixed
     */
    public function afterExecute($subject, $result)
    {
        $enable = $this->scopeConfig->getValue(
            'mobi_advance/modules_features/mobi_inapppayment',
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );

        if ($this->checkoutSession->getMobiInAppPayment() && $enable) {
            $session = $subject->getOnepage()->getCheckout();
            $appType = $this->checkoutSession->getMobiStripeAppType();
            if($appType == "localhost"){
                return $this->redirectFactory->create()->setUrl('http://localhost:3000/mobiinapppayment/checkout/failure?increment_id='.$session->getLastRealOrder()->getIncrementId());

            } else {
                return $this->redirectFactory->create()->setUrl($this->getPWAUrl().'/mobiinapppayment/checkout/failure?increment_id='.$session->getLastRealOrder()->getIncrementId());
            }
        }

        return $result;
    }
}
