<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_MagentoGraphQlPatch
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\MagentoGraphQlPatch\Plugin\Magento\CatalogGraphQl\DataProvider\Product\LayeredNavigation\Builder;

use Magento\Framework\App\ResourceConnection;

class AttributeDataProvider
{
    /**
     * @var ResourceConnection
     */
    private ResourceConnection $resourceConnection;

    /**
     * @param ResourceConnection $resourceConnection
     */
    public function __construct(
        ResourceConnection $resourceConnection
    ) {
        $this->resourceConnection = $resourceConnection;
    }

    /**
     * Get root category for specified store id
     *
     * @param string $attributeCode
     * @param int $storeId
     * @return mixed
     */
    public function getAttributeData(string $attributeCode, int $storeId)
    {
        $connection = $this->resourceConnection->getConnection();

        $select = $connection->select()
            ->from(
                ['attribute' => $this->resourceConnection->getTableName('eav_attribute')]
            )
            ->joinLeft(
                ['attribute_label' => $this->resourceConnection->getTableName('eav_attribute_label')],
                "attribute.attribute_id = attribute_label.attribute_id AND attribute_label.store_id = {$storeId}",
                [
                    'attribute_store_label' => 'attribute_label.value',
                ]
            )
            ->where('attribute.attribute_code = ?', $attributeCode);

        return $connection->fetchRow($select);
    }
}
