<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_MagentoGraphQlPatch
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\MagentoGraphQlPatch\Plugin\Magento\ReviewGraphQl\Model\Resolver\Product;
use Magento\Review\Model\Review;
use Magento\Review\Model\Review\Config as ReviewsConfig;
class ReviewCount
{
    /**
     * @var Review
     */
    private $review;

    /**
     * @var ReviewsConfig
     */
    private $reviewsConfig;

    /**
     * @param Review $review
     * @param ReviewsConfig $reviewsConfig
     */
    public function __construct(Review $review, ReviewsConfig $reviewsConfig)
    {
        $this->review = $review;
        $this->reviewsConfig = $reviewsConfig;
    }

    public function afterResolve($subject, $result,$field,$context,$info,array $value = null,
    array $args = null)
    {
        if (false === $this->reviewsConfig->isEnabled()) {
            return 0;
        }

        if (!isset($value['model'])) {
            throw new GraphQlInputException(__('Value must contain "model" property.'));
        }

        $product = $value['model'];
        
        $store = $context->getExtensionAttributes()->getStore();

        return (int) $this->review->getTotalReviews($product->getId(), true,$store->getId());
       
    }
}
