<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_MagentoGraphQlPatch
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\MagentoGraphQlPatch\Plugin\Magento\ReviewGraphQl\Model\Resolver;
use Magento\Framework\App\ResourceConnection;
class ProductReviewRatingsMetadata
{
    protected $resource;

    public function __construct(
        ResourceConnection $resource
    ) {
        $this->resource = $resource;
    }

    public function afterResolve($subject, $result,$field,$context)
    {
       
        $store = $context->getExtensionAttributes()->getStore();
       
        $connection  = $this->resource->getConnection();
      
        $table = $connection->getTableName('rating_title');
      
        foreach($result['items'] as &$review)
        {
            //assign default title
            $review['title'] = $review['name'];
          
            $ratingId = base64_decode($review['id']);
            $select = $connection->select()->from($table, ['store_id', 'value'])
            ->where('rating_id = :rating_id and store_id = :store_id');
            $title = $connection->fetchPairs($select, [':rating_id' => $ratingId,':store_id' => $store->getId()]);     
            //if title exist for the store view then replace it
            //echo json_encode($title);//exit;
            if($title && isset($title[$store->getId()]))
            {
                $review['title'] = $title[$store->getId()];
            }
           
        }
       
        return $result;
    }
}
