<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_UrlRewriteGraphQl
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\MagentoGraphQlPatch\Plugin\Magento\UrlRewriteGraphQl\Model\Resolver;

class EntityUrl
{
    public function __construct(
        \Magento\Catalog\Model\ProductRepository $productRepository,
        \Magento\Framework\Event\ManagerInterface $eventManager,
        \Magento\Framework\Registry $registry
    ) {
       
        $this->_productRepository = $productRepository;
        $this->_eventManager = $eventManager;
       
        $this->_coreRegistry = $registry;
       
    }

    public function afterResolve($subject, $result, $field,
    $context,
    $info,
    array $value = null,
    array $args = null)
    {
        if (isset($result['type']) && $result['type'] == 'PRODUCT' ) {
              
                $product = $this->_productRepository->getById($result['id']);
               
                $result['url_key'] = $product->getUrlKey();
                $result['sku'] = $product->getSku();
            }
          
        return $result;
    }


   
}
