<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Api;

/**
 * Mobiapp Information Exchange
 */
interface MobiappRepositoryInterface
{
    /**
     * When creating new application,
     *
     * This call will be performed to check if store is online
     *
     * @return boolean
     */
    public function isOnline();

    /**
     * This will push data from mobi server to magento db
     *
     * @param string $appcode
     * @param string $appkey
     * @param \Mobicommerce\Mobiapp\Api\Data\MobiappDataInterface $params
     * @return boolean
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function pushInformationFromMobiServer($appcode, $appkey, $params);

    /**
     * This will delete mobiapp from magento db
     *
     * @param string $appcode
     * @param string $appkey
     * @return boolean
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteMobiapp($appcode, $appkey);
}
