<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\Deeplink\Container\Tab;

class Productcollection extends \Magento\Backend\Block\Widget\Grid\Extended
{
    /**
     * Productcollection constructor.
     *
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Backend\Helper\Data $backendHelper
     * @param \Mobicommerce\Mobiapp\Model\ProductcollectionFactory $productcollectionFactory
     * @param array $data
     */

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Backend\Helper\Data $backendHelper,
        \Mobicommerce\Mobiapp\Model\ProductcollectionFactory $productcollectionFactory,
        array $data = []
    ) {
        $this->productcollectionFactory = $productcollectionFactory;
        parent::__construct($context, $backendHelper, $data);
    }

    /**
     * Construct
     *
     * @return void
     */
    protected function _construct()
    {
        parent::_construct();
        $this->setId('deepink_productcollection');
        $this->setDefaultSort('id');
        $this->setUseAjax(true);
    }

    /**
     * Prepare Collection
     *
     * @return Grid
     */
    protected function _prepareCollection()
    {
        $collection = $this->productcollectionFactory->create()->getCollection();
        $this->setCollection($collection);
        return parent::_prepareCollection();
    }

    /**
     * Prepare columns
     *
     * @return Extended
     */
    protected function _prepareColumns()
    {
        $this->addColumn(
            'id',
            [
                'header'           => __('ID'),
                'sortable'         => true,
                'index'            => 'id',
                'type'             => 'number',
                'header_css_class' => 'col-id',
                'column_css_class' => 'col-id'
            ]
        );
        $this->addColumn('name', [
            'header' => __('Name'),
            'index' => 'name'
        ]);
        $this->addColumn('short_description', [
            'header' => __('Short Description'),
            'index' => 'short_description'
        ]);

        return parent::_prepareColumns();
    }

    /**
     * Get grid url
     *
     * @return string
     */
    public function getGridUrl()
    {
        return $this->getUrl('mobicommerce/deeplink/productcollectiongrid', ['_current' => true]);
    }
}
