<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\Mobiapp\Edit\Container;

class Information extends \Magento\Backend\Block\Template
{
     /**
      * @var _template
      */
    protected $_template = 'mobiapp/container/information.phtml';

     /**
      * @var mobiapp
      */
    private $mobiapp = null;

    /**
     * Information constructor
     *
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param array $data
     * @return array
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->registry = $registry;
    }

    /**
     * Get mobi app
     *
     * @return object
     */
    public function getMobiapp()
    {
        if ($this->mobiapp == null) {
            $this->mobiapp = $this->registry->registry('mobicommerce_mobiapp');
        }

        return $this->mobiapp;
    }
}
