<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\System\Form\Field\DynamicRows;

use Magento\Framework\View\Element\Html\Select;

class CmsPages extends Select
{
    /**
     * Cmspages constructor
     *
     * @param \Magento\Framework\View\Element\Context $context
     * @param \Magento\Cms\Model\Config\Source\Page $page
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Context $context,
        \Magento\Cms\Model\Config\Source\Page $page,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->page = $page;
    }
    
    /**
     * Set "name" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputName($value)
    {
        return $this->setName($value);
    }

    /**
     * Set "id" for <select> element
     *
     * @param object $value
     * @return $this
     */
    public function setInputId($value)
    {
        return $this->setId($value);
    }

    /**
     * Render block HTML
     *
     * @return string
     */
    public function _toHtml(): string
    {
        if (!$this->getOptions()) {
            $this->setOptions($this->getSourceOptions());
        }
        return parent::_toHtml();
    }

    /**
     * Getsourceoptions
     *
     * @return array
     */
    private function getSourceOptions(): array
    {
        return $this->page->toOptionArray();
    }
}
