<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\System\Form\Field\DynamicRows;

use Magento\Framework\View\Element\Html\Select;

class SocialMedia extends Select
{

    /**
     * Set "name" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputName($value)
    {
        return $this->setName($value);
    }

    /**
     * Set "id" for <select> element
     *
     * @param object $value
     * @return $this
     */
    public function setInputId($value)
    {
        return $this->setId($value);
    }

    /**
     * Render block HTML
     *
     * @return string
     */
    public function _toHtml(): string
    {
        if (!$this->getOptions()) {
            $this->setOptions($this->getSourceOptions());
        }
        return parent::_toHtml();
    }

    /**
     * Getsource options
     *
     * @return array
     */
    private function getSourceOptions(): array
    {
        return [
            ['value' => 'facebook', 'label' => 'Facebook'],
            ['value' => 'twitter', 'label' => 'Twitter'],
            ['value' => 'instagram', 'label' => 'Instagram'],
            ['value' => 'linkedin', 'label' => 'Linkedin'],
            ['value' => 'pinterest', 'label' => 'Pinterest'],
            ['value' => 'youtube', 'label' => 'Youtube'],
            ['value' => 'blog', 'label' => 'Blog'],
            ['value' => 'googleplus', 'label' => 'Googleplus'],
            ['value' => 'telegram', 'label' => 'Telegram'],
            ['value' => 'whatsapp', 'label' => 'Whatsapp']
        ];
    }
}
