<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\Widget\Container;

class AssignMobicommerceCmsPage extends \Magento\Backend\Block\Template
{
    /**
     * Block template
     *
     * @var string
     */
    protected $_template = 'widget/container/assign_mobicommerce_cms_page.phtml';

    /**
     * @var \Magento\Catalog\Block\Adminhtml\Category\Tab\Product
     */
    protected $blockGrid;

    /**
     * AssignProducts constructor.
     *
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        array $data = []
    ) {
        $this->registry = $registry;
        parent::__construct($context, $data);
    }

    /**
     * Retrieve instance of grid block
     *
     * @return \Magento\Framework\View\Element\BlockInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getBlockGrid()
    {
        if (null === $this->blockGrid) {
            $this->blockGrid = $this->getLayout()->createBlock(
                \Mobicommerce\Mobiapp\Block\Adminhtml\Widget\Container\Tab\MobicommerceCmsPage::class,
                'widget.mobicommercecmspage.grid'
            );
        }
        return $this->blockGrid;
    }

    /**
     * Return HTML of grid block
     *
     * @return string
     */
    public function getGridHtml()
    {
        return $this->getBlockGrid()->toHtml();
    }

    /**
     * Get selected page id
     *
     * @return string
     */
    public function getSelectedPageId()
    {
        $pageId = false;
        
        $widgetId = $this->getWidget()->getId();
        if ($widgetId) {
            $pageId = $this->getWidget()->getMobicommerceCmsPageId();
        }

        if (!$pageId) {
            $pageId = 0;
        }

        return $pageId;
    }

    /**
     * Retrieve current widget instance
     *
     * @return array|null
     */
    public function getWidget()
    {
        return $this->registry->registry('mobicommerce_widget');
    }

    /**
     * Get ui component name
     *
     * @return array|null
     */
    public function getUiComponentName()
    {
        return 'mobicommerce_widget_form_' . $this->getWidget()->getType();
    }
}
