<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\Widget\Edit\Container;

use Magento\Framework\Serialize\Serializer\Serialize;
use Mobicommerce\Mobiapp\Helper\Image as ImageHelper;

class ImageMapping extends \Magento\Backend\Block\Template
{
    /**
     * String _template
     *
     * @var _template
     */
    protected $_template = 'widget/container/image_mapping.phtml';
    
     /**
      * ImageMapping constructor.
      *
      * @param \Magento\Backend\Block\Template\Context $context
      * @param \Magento\Framework\Registry $registry
      * @param \Magento\Framework\Serialize\Serializer\Serialize $serialize
      * @param \Mobicommerce\Mobiapp\Helper\Image $imageHelper
      * @param array $data
      */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        Serialize $serialize,
        ImageHelper $imageHelper,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->registry = $registry;
        $this->serialize = $serialize;
        $this->imageHelper = $imageHelper;
    }

     /**
      * Retrieve instance of grid block
      *
      * @return widget id
      */
    public function displayMappingHtml()
    {
        $widget = $this->registry->registry('mobicommerce_widget');
        return $widget->getId() ? true : false;
    }

     /**
      * Retrieve instance of grid block
      *
      * @return widget image
      */
    public function getImageMapImage()
    {
        $imageUrl = false;
        //$imageUrl = "https://picsum.photos/1920/460?image=660";

        $widget = $this->registry->registry('mobicommerce_widget');
        $widgetSpecificOptions = $widget->getData('widget_specific_options');
        if ($widgetSpecificOptions) {
            $widgetSpecificOptions = $this->serialize->unserialize($widgetSpecificOptions);
            $image = $widgetSpecificOptions['image'] ?? false;
            if ($image) {
                $imageUrl = $this->imageHelper->getFileUrl($image);
            }
        }

        return $imageUrl;
    }
     /**
      * Retrieve instance of image map
      *
      * @return widget image map
      */
    public function getImageMap()
    {
        $imagemap = false;

        $widget = $this->registry->registry('mobicommerce_widget');
        $widgetSpecificOptions = $widget->getData('widget_specific_options');
        if ($widgetSpecificOptions) {
            $widgetSpecificOptions = $this->serialize->unserialize($widgetSpecificOptions);
            $imagemap = $widgetSpecificOptions['imagemap'] ?? false;
        }

        return $imagemap;
    }
}
