<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Block\Adminhtml\Widget;

use Mobicommerce\Mobiapp\Model\Config\Source\WidgetType;

class Listing extends \Magento\Backend\Block\Widget\Container
{
    /**
     * Constructor
     *
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param WidgetType $widgetType
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context,
        WidgetType $widgetType,
        array $data = []
    ) {
        $this->widgetType = $widgetType;
        parent::__construct($context, $data);
    }

    /**
     * Preapre layout
     *
     * @return object
     */
    protected function _prepareLayout()
    {
        $addButtonProps = [
            'id' => 'add_new_widget',
            'label' => __('Add Widget'),
            'class' => 'save primary',
            'button_class' => '',
            'data_attribute' => [
                'mage-init' => [
                    'Magento_Ui/js/form/button-adapter' => [
                        'actions' => [
                            [
                                'targetName' => 'mobicommerce_widget_listing.mobicommerce_widget_listing.widget_modal',
                                'actionName' => 'openModal'
                            ]
                        ]
                    ]
                ],
                'url' => $this->getWidgetCreateUrl('REPLACE_WIDGET_TYPE'),
            ],
        ];
        $this->buttonList->add('add_new', $addButtonProps);

        return parent::_prepareLayout();
    }

    /**
     * Retrieve widget create url by specified widget type
     *
     * @param string $type
     * @return string
     */
    protected function getWidgetCreateUrl($type)
    {
        return $this->getUrl(
            '*/*/new',
            ['type' => $type]
        );
    }
}
