<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Mobicommerce\Mobiapp\Model\CustomsegmentRepository;

class RunPushCustomSegmentSyncCommand extends Command
{
    /**
     * @var CustomsegmentRepository
     */
    private CustomsegmentRepository $customsegmentRepository;

    /**
     * Constructor
     *
     * @param CustomsegmentRepository $customsegmentRepository
     * @param string|null $name
     */
    public function __construct(
        CustomsegmentRepository $customsegmentRepository,
        string $name = null
    ) {
        parent::__construct($name);
        $this->customsegmentRepository = $customsegmentRepository;
    }

    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $this->setName('mobi:push:customsegmentsync');
        $this->setDescription('Sync Custom Segment');

        parent::configure();
    }

    /**
     * @inheritDoc
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->customsegmentRepository->processQueue();
    }
}
