<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Controller\Adminhtml\Customsegment;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\Exception\LocalizedException;
use Mobicommerce\Mobiapp\Model\CustomsegmentFactory;
use Mobicommerce\Mobiapp\Model\CustomsegmentRepository;

class Queueadd extends Action
{
    public const ADMIN_RESOURCE = 'Mobicommerce_Mobiapp::custom_segment';

    /**
     * @var CustomsegmentFactory
     */
    private CustomsegmentFactory $customsegmentFactory;

    /**
     * @var CustomsegmentRepository
     */
    private CustomsegmentRepository $customsegmentRepository;

    /**
     * Constructor
     *
     * @param Context $context
     * @param CustomsegmentFactory $customsegmentFactory
     * @param CustomsegmentRepository $customsegmentRepository
     */
    public function __construct(
        Action\Context $context,
        CustomsegmentFactory $customsegmentFactory,
        CustomsegmentRepository $customsegmentRepository
    ) {
        parent::__construct($context);
        $this->customsegmentFactory = $customsegmentFactory;
        $this->customsegmentRepository = $customsegmentRepository;
    }

    /**
     * Execute action
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();

        $id = $this->getRequest()->getParam('id', 0);

        try {
            $this->customsegmentRepository->queueAdd($id);
        } catch (LocalizedException $e) {
            $this->messageManager->addErrorMessage($e->getMessage());
            $resultRedirect = $this->resultRedirectFactory->create();
            return $resultRedirect->setPath('*/*/');
        }

        return $resultRedirect->setPath('*/*/');
    }
}
