<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Controller\Adminhtml\Translation;

use Magento\Backend\App\Action;
use Mobicommerce\Mobiapp\Block\Adminhtml\Language\Switcher;

class Edit extends Action
{
    public const ADMIN_RESOURCE = 'Mobicommerce_Mobiapp::translation';

    /**
     * @var PageFactory
     */
    protected $resultPageFactory = false;

    /**
     * @param Context $context
     * @param PageFactory $resultPageFactory
     * @param Switcher $switcher
     */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        Switcher $switcher
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
        $this->switcher = $switcher;
    }

    /**
     * Execute action
     */
    public function execute()
    {
        $language = $this->getRequest()->getParam('language');

        $languages = $this->switcher->getLanguages();
        if (!array_key_exists($language, $languages)) {
            $resultRedirect = $this->resultRedirectFactory->create();
            return $resultRedirect->setPath('*/*/*', [
                'language' => array_keys($languages)[0]
            ]);
        }

        $resultPage = $this->resultPageFactory->create();
        $resultPage->setActiveMenu('Mobicommerce_Mobiapp::translation');
        $resultPage->getConfig()->getTitle()->prepend((__('Labels &amp; Messages')));
        
        return $resultPage;
    }
}
