<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Controller\Adminhtml\Widget;

use Magento\Backend\App\Action;

class Index extends Action
{
    public const ADMIN_RESOURCE = 'Mobicommerce_Mobiapp::widget';

    /**
     * @var PageFactory
     */
    protected $resultPageFactory = false;

     /**
      * @param Context $context
      * @param PageFactory $resultPageFactory
      */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
    }

    /**
     * Execute action
     */
    public function execute()
    {
        $resultPage = $this->resultPageFactory->create();
        $resultPage->setActiveMenu('Mobicommerce_Mobiapp::widget');
        $resultPage->getConfig()->getTitle()->prepend((__('Widgets')));

        return $resultPage;
    }
}
