<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Store\Model\StoreManagerInterface;
use Magento\Store\Model\ScopeInterface;

class Config extends AbstractHelper
{
    public const MOBICOMMERCE_SERVER_DOMAIN = "https://cloud2.dmob.in/";
    public const MOBICOMMERCE_VERSION = "2.1.0";
    public const CONNECTION_VERSION = "90c4203d29f077997e7c4e11ce402a93d604dab6";
    public const ONESIGNAL_APPID = "e1b7f9d9-6c2c-4df3-aa1f-b5fcd9b6a542";
    public const ONESIGNAL_REST_API_KEY = "NNjQxNTAwYmYtNjJiYS00NzhkLTlkMjQtMjIzZmMxZjFkM2Jm";
    public const GCM_SENDER_ID = "881306584774";
    public const VENTURE = "MOBICOMMERCE";
    public const BUNDLE_ID = "com.mobicommerce.sampleapp";
    public const IOS_APP_ID = "910995460";
    public const ANDROID_PUSH_NOTIFICATION_KEY = "AAAAx2bCCh0" .
    ":APA91bE9qhYNXNE0sdJIwZkoEyEJafVI1Su4sluN7RpVIdnj7w75riPoFrwAQ-" .
    "_igncg8nnoEFfWTlND2atsLrjTKKGG8h8Ix5qayEp_" .
    "hblCvNG4y3lPpmxPaewh752Uxfv6ube8b-ql";
    public const ANDROID_PUSH_NOTIFICATION_SENDER_ID = "856422484509";
    public const FACEBOOK_PAGE_URL = "https://www.facebook.com/mobi.commerce.platform";
    public const TWITTER_PAGE_URL = "https://twitter.com/mobicommerceapp";
    public const MOBIAPP_ICON_UPLOAD_PATH = "mobicommerce/mobiapp/assets/icon";
    public const MOBIAPP_ICON_UPLOAD_TMP_PATH = "mobicommerce/mobiapp/assets/icon/tmp";
    public const MOBIAPP_SPLASH_UPLOAD_PATH = "mobicommerce/mobiapp/assets/splash";
    public const MOBIAPP_SPLASH_UPLOAD_TMP_PATH = "mobicommerce/mobiapp/assets/splash/tmp";
    public const MOBIAPP_FAVICON_UPLOAD_PATH = "mobicommerce/mobiapp/assets/favicon";
    public const MOBIAPP_FAVICON_UPLOAD_TMP_PATH = "mobicommerce/mobiapp/assets/favicon/tmp";
    public const IMAGE_IMAGECOLLECTION_UPLOAD_PATH = "mobicommerce/image_collection";
    public const IMAGE_IMAGECOLLECTION_UPLOAD_TMP_PATH = "mobicommerce/image_collection/tmp";
    public const SECTION_IMAGE_UPLOAD_PATH = "mobicommerce/section";
    public const SECTION_IMAGE_UPLOAD_TMP_PATH = "mobicommerce/section/tmp";
    public const IMAGEMAP_IMAGE_UPLOAD_PATH = "mobicommerce/imagemap";
    public const IMAGEMAP_IMAGE_UPLOAD_TMP_PATH = "mobicommerce/imagemap/tmp";
    public const PAGEBUILDER_PREVIEW_SLUG = "previewLandingPage";

    /**
     * @param StoreManagerInterface $storeManager
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        StoreManagerInterface $storeManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        parent::__construct($context);
        $this->storeManager = $storeManager;
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * GetStoreUrl function
     */
    public function getStoreUrl()
    {
        $isHeadlessEnable = $this->scopeConfig->getValue(
            'mobi_basic/headless/is_enable',
            ScopeInterface::SCOPE_STORE
        );
        if ($isHeadlessEnable) {
            $headlessUrl = $this->scopeConfig->getValue(
                'mobi_basic/headless/frontend_url',
                ScopeInterface::SCOPE_STORE
            );
            if (!empty(trim($headlessUrl))) {
                return rtrim(str_replace(" ","",$headlessUrl),'/');
            }
        }

        return $this->storeManager->getStore()->getBaseUrl();
    }
}
