<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Category\Attribute\Backend;

use Magento\Eav\Model\Entity\Attribute\Backend\AbstractBackend;

class SeoWidgetIds extends AbstractBackend
{
    /**
     * Beforesave function
     *
     * @param object $object
     * @return object
     */
    public function beforeSave($object)
    {
        $dynamicRowsField = 'mobicommerce_seo_widgets_dynamic_rows';
        if ($seoWidgets = $object->getData($dynamicRowsField)) {
            $seoWidgets = $seoWidgets[$dynamicRowsField] ?? false;
            if ($seoWidgets) {
                $position = [];
                foreach ($seoWidgets as $key => $item) {
                    $position[$key] = $item['position'];
                }
                array_multisort($position, SORT_ASC, $seoWidgets);

                $widgetIds = [];
                foreach ($seoWidgets as $widget) {
                    $widgetIds[] = $widget['id'];
                }

                $seoWidgets = implode(',', $widgetIds);
                $object->setData($this->getAttribute()->getName(), $seoWidgets);
            }
        } else {
            $object->setData($this->getAttribute()->getName(), null);
        }

        parent::beforeSave($object);
        return $this;
    }
}
