<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Category\Attribute\Source;

use Magento\Eav\Model\Entity\Attribute\Source\AbstractSource;
use Mobicommerce\Mobiapp\Model\ResourceModel\PageBuilder\CollectionFactory;

class MobicommercePageBuilder extends AbstractSource
{
    /**
     * Mobi pagebuilder constructor.
     *
     * @param \Mobicommerce\Mobiapp\Model\ResourceModel\PageBuilder\CollectionFactory $collectionFactory
     */
    public function __construct(
        CollectionFactory $collectionFactory
    ) {
        $this->collectionFactory = $collectionFactory;
    }

     /**
      * Retrieve all options
      *
      * @return object
      */
    public function getAllOptions()
    {
        if (!$this->_options) {
            $this->_options = [
                ['value' => '', 'label' => __('------ SELECT ------')]
            ];

            $collection = $this->collectionFactory->create();
            if ($collection->getSize()) {
                foreach ($collection as $item) {
                    $this->_options[] = ['value' => $item->getId(), 'label' => $item->getName()];
                }
            }
        }
        return $this->_options;
    }
}
