<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class MobicommerceCmsPageType implements OptionSourceInterface
{
    /**
     * DEFAULT
     */
    public const DEFAULT = "magento_cms";

    /**
     * @var data
     */
    protected $data = [];
    
    /**
     * MobicommerceCmsPageType constructor.
     *
     * @param array $data
     */
    public function __construct(
        array $data = []
    ) {
        $this->data = $data;
    }
    
     /**
      * Convert to Array
      *
      * @return object
      */
    public function toOptionArray()
    {
        $result[] = [
            'value' => '',
            'label' => __('------ SELECT ------')
        ];
        
        foreach ($this->getTypes() as $typeId => $label) {
            $result[] = [
                'value' => $typeId,
                'label' => $label
            ];
        }

        return $result;
    }

     /**
      * Fetch types
      *
      * @return object
      */
    public function getTypes()
    {
        $result = [];
        $result[''] = __('ALL');
        foreach ($this->data as $code => $item) {
            $result[$code] = $item['label'];
        }

        return $result;
    }

     /**
      * Get Types without default
      *
      * @return object
      */
    public function getTypesWithoutDefault()
    {
        $result = $this->getTypes();
        unset($result[self::DEFAULT]);

        return $result;
    }
}
