<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;
use Mobicommerce\Mobiapp\Model\ResourceModel\PageBuilder\CollectionFactory;

class MobicommercePageBuilder implements OptionSourceInterface
{
    /**
     * AssignProducts constructor.
     *
     * @param Mobicommerce\Mobiapp\Model\ResourceModel\PageBuilder\CollectionFactory $collectionFactory
     */
    public function __construct(
        CollectionFactory $collectionFactory
    ) {
        $this->collectionFactory = $collectionFactory;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result[] = [
            'value' => '',
            'label' => __('------ SELECT ------')
        ];
        
        $collection = $this->collectionFactory->create();
        if ($collection->getSize()) {
            foreach ($collection as $item) {
                $result[] = [
                    'value' => $item->getId(),
                    'label' => $item->getName()
                ];
            }
        }

        return $result;
    }
}
