<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class PageBuilderType implements OptionSourceInterface
{
    public const DEFAULT_TYPE = 'landing_page';

    /**
     * Convert to Array
     *
     * @return object
     */

    public function toOptionArray()
    {
        $result = [];
        $result[] = [
            'value' => '',
            'label' => __('------ SELECT ------')
        ];

        $types = $this->getTypes();
        foreach ($types as $typeId => $item) {
            $result[] = [
                'value' => $typeId,
                'label' => $item['label']
            ];
        }

        return $result;
    }

    /**
     * Fetch types
     *
     * @return object
     */
    public function getTypes()
    {
        $result = [
            'product_listing_page' => ['label' => __('Product Listing Page'), 'sort_order' => 10],
            'landing_page' => ['label' => __('Landing Page'), 'sort_order' => 20]
        ];
        
        return $result;
    }

    /**
     * Check isvalid
     *
     * @param array $pageBuilderType
     * @return array
     */
    public function isValid($pageBuilderType)
    {
        return in_array($pageBuilderType, array_keys($this->getTypes()));
    }
}
