<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class WidgetImageEffect implements OptionSourceInterface
{
    /**
     * @var $data
     */
    protected $data = [];
    
    /**
     * WidgetImageEffect constructor.
     *
     * @param array $data
     */
    public function __construct(
        array $data = []
    ) {
        $this->data = $data;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result = [];

         $result = [
            ['value' => '', 'label' => __('------ SELECT ------')],
            ['value' => 'zoom_in', 'label' => __('Zoom In')],
            ['value' => 'zoom_out', 'label' => __('Zoom Out')],
            ['value' => 'drop_shadow', 'label' => __('Drop Shadow')],
            ['value' => 'filter_sepia', 'label' => __('Filter Sepia')],
            ['value' => 'filter_grayscale', 'label' => __('Filter Grayscale')],
            ['value' => 'filter_contrast', 'label' => __('Filter Contrast')],
            ['value' => 'filter_brightness', 'label' => __('Filter Brightness')],
            ['value' => 'filter_saturate', 'label' => __('Filter Saturate')],
            ['value' => 'animation_filter_sepia', 'label' => __('Animation Filter Sepia')],
            ['value' => 'animation_circle', 'label' => __('Animation Circle')]
         ];
         
         return $result;
    }
}
