<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class WidgetStyle implements OptionSourceInterface
{
    /**
     * @var array $data
     */
    protected $data = [];
    
    /**
     * WidgetStyle constructor.
     *
     * @param \Magento\Framework\App\RequestInterface $request
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\App\RequestInterface $request,
        array $data = []
    ) {
        $this->request = $request;
        $this->data = $data;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result = [];

        $widgetType = $this->request->getParam('type', null);
        $styles = $this->data[$widgetType] ?? false;

        if ($styles) {
            foreach ($styles as $code => $item) {
                $result[] = [
                    'value' => $code,
                    'label' => $item['label']
                ];
            }
        }
        
        return $result;
    }
}
