<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class WidgetTopType implements OptionSourceInterface
{
    /**
     * @var array $data
     */
    protected $data = [];
    
    /**
     * WidgetSeoType constructor.
     *
     * @param WidgetType $widgetType
     */
    public function __construct(
        WidgetType $widgetType
    ) {
        $this->widgetType = $widgetType;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result = [];

        $types = $this->widgetType->getTypes();
        foreach ($types as $typeId => $item) {
           
                $result[] = [
                    'value' => $typeId,
                    'label' => $item['label']
                ];
           
        }

        return $result;
    }
}
