<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class WidgetType implements OptionSourceInterface
{
    /**
     * @var array $data
     */
    protected $data = [];
    
    /**
     * WidgetStyle constructor.
     *
     * @param array $data
     */
    public function __construct(
        array $data = []
    ) {
        $this->data = $data;
    }

    /**
     * Convert to Array
     *
     * @return object
     */
    public function toOptionArray()
    {
        $result = [];
        $result[] = [
            'value' => '',
            'label' => __('------ SELECT ------')
        ];

        $types = $this->getTypes();
        foreach ($types as $typeId => $item) {
            $result[] = [
                'value' => $typeId,
                'label' => $item['label']
            ];
        }

        return $result;
    }

    /**
     * Fetch type
     *
     * @return object
     */
    public function getTypes()
    {
        return $this->data;
    }

    /**
     * Check isvalid
     *
     * @param array $widgetType
     * @return object
     */
    public function isValid($widgetType)
    {
        return in_array($widgetType, array_keys($this->getTypes()));
    }

    /**
     * Fetch lable by type
     *
     * @param array $type
     * @return object
     */
    public function getLabelByType($type)
    {
        return $this->getTypes()[$type]['label'];
    }
}
