<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model;

use Magento\Framework\DataObject\IdentityInterface;
use Magento\Framework\Model\AbstractModel;
use Mobicommerce\Mobiapp\Api\Data\MobiappDataInterface;

class Mobiapp extends AbstractModel implements
    IdentityInterface,
    MobiappDataInterface
{
    /**
     * Mobiapp cache tag
     */
    public const CACHE_TAG = 'mobicommerce_mobiapp';

    /**
     * @var string
     */
    protected $_cacheTag = self::CACHE_TAG;

    /**
     * Prefix of model events names
     *
     * @var string
     */
    protected $_eventPrefix = self::CACHE_TAG;

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init(
            \Mobicommerce\Mobiapp\Model\ResourceModel\Mobiapp::class
        );
    }

    /**
     * Get identities
     *
     * @return array
     */
    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    /**
     * Set androidurl
     *
     * @param string $url
     * @return array
     */
    public function setAndroidUrl($url)
    {
        $this->setData('android_url', $url);
        return $this;
    }

    /**
     * Get androidurl
     *
     * @return array
     */
    public function getAndroidUrl()
    {
        return $this->getData('android_url');
    }

    /**
     * Set DesktopUrl
     *
     * @param string $url
     * @return array
     */
    public function setDesktopUrl($url)
    {
        $this->setData('desktop_url', $url);
        return $this;
    }

    /**
     * Get DesktopUrl
     *
     * @return array
     */
    public function getDesktopUrl()
    {
        return $this->getData('desktop_url');
    }

    /**
     * Set PWAUrl
     *
     * @param string $url
     * @return array
     */
    public function setPwaUrl($url)
    {
        $this->setData('pwa_url', $url);
        return $this;
    }

    /**
     * Get PWAUrl
     *
     * @return array
     */
    public function getPwaUrl()
    {
        return $this->getData('pwa_url');
    }
}
