<?php
/**
 * Mobicommerce
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Model\ResourceModel\Section;

use Magento\Framework\Model\ResourceModel\Db\Collection\AbstractCollection;

class Collection extends AbstractCollection
{
    /**
     * @var string
     */
    protected $_idFieldName = 'id';

    /**
     * @var string
     */
    protected $_eventPrefix = 'mobicommerce_section_collection';

    /**
     * @var string
     */
    protected $_eventObject = 'mobicommerce_section_collection';

    /**
     * Define resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init(
            \Mobicommerce\Mobiapp\Model\Section::class,
            \Mobicommerce\Mobiapp\Model\ResourceModel\Section::class
        );
    }

    /**
     * Add enable status filter
     *
     * @return void
     */
    public function addEnableStatusFilter()
    {
        $this->addFieldToFilter('enable', 1);
        return $this;
    }
}
