<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;
use Mobicommerce\Mobiapp\Helper\StaticFiles;

class GenerateStaticFilesOnCacheFlush implements ObserverInterface
{
    /**
     * @param StaticFiles $staticFilesHelper
     */
    public function __construct(
        StaticFiles $staticFilesHelper
    ) {
        $this->staticFilesHelper = $staticFilesHelper;
    }

    /**
     * Execute action
     *
     * @param Observer $observer
     */
    public function execute(Observer $observer)
    {
        $this->staticFilesHelper->writeAllStoreJs();
    }
}
