<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Plugin\Magento\Cms\Controller\Adminhtml\Page;

class PostDataProcessor
{
    /**
     * AfterFilter
     *
     * @param PostData $subject
     * @param Result $result
     * @param Input $data
     */
    public function afterFilter($subject, $result, $data)
    {
        $mobicommercePageType = $result['mobicommerce_page_type'] ?? false;
        switch ($mobicommercePageType) {
            case 'magento_cms':
                $result['mobicommerce_pwa_landing_page_id'] = null;
                $result['mobicommerce_desktop_landing_page_id'] = null;
                $result['mobicommerce_mobileapp_landing_page_id'] = null;
                $result['mobicommerce_product_collection_id'] = null;
                break;

            case 'mobicommerce_product_listing_page':
                $result['mobicommerce_pwa_landing_page_id'] = null;
                $result['mobicommerce_desktop_landing_page_id'] = null;
                $result['mobicommerce_mobileapp_landing_page_id'] = null;
                break;

            case 'mobicommerce_landing_page':
                $result['mobicommerce_product_collection_id'] = null;
                break;
            
            default:
                # code...
                break;
        }
        
        return $result;
    }
}
