<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Setup\Patch\Data;

use Magento\Framework\Setup\Patch\DataPatchInterface;
use Magento\Framework\Setup\Patch\PatchRevertableInterface;
use Mobicommerce\Mobiapp\Helper\StaticFiles;

class GenerateStaticFiles implements
    DataPatchInterface,
    PatchRevertableInterface
{
    /**
     * @var \Magento\Framework\Setup\ModuleDataSetupInterface
     */
    private $moduleDataSetup;

    /**
     * @param \Magento\Framework\Setup\ModuleDataSetupInterface $moduleDataSetup
     * @param StaticFiles $staticFilesHelper
     */
    public function __construct(
        \Magento\Framework\Setup\ModuleDataSetupInterface $moduleDataSetup,
        StaticFiles $staticFilesHelper
    ) {
        $this->moduleDataSetup = $moduleDataSetup;
        $this->staticFilesHelper = $staticFilesHelper;
    }

    /**
     * Apply patch
     */
    public function apply()
    {
        $this->moduleDataSetup->getConnection()->startSetup();
        $this->staticFilesHelper->writeAllStoreJs();
        $this->moduleDataSetup->getConnection()->endSetup();
    }

    /**
     * GetDependencies patch
     */
    public static function getDependencies()
    {
        return [];
    }

    /**
     * Revert patch
     */
    public function revert()
    {
        $this->moduleDataSetup->getConnection()->startSetup();
        $this->moduleDataSetup->getConnection()->endSetup();
    }

    /**
     * GetAliases patch
     */
    public function getAliases()
    {
        return [];
    }
}
