<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\Image\Form\Modifier;

use Magento\Framework\App\RequestInterface;
use Magento\Framework\UrlInterface;
use Mobicommerce\Mobiapp\Ui\DataProvider\Deeplink\Form\ModalMetaProvider as DeeplinkModalMetaProvider;

class DeeplinkModal extends AbstractModifier
{
    /**
     * DeeplinkModal constructor.
     *
     * @param RequestInterface $request
     * @param UrlInterface $urlBuilder
     * @param DeeplinkModalMetaProvider $deeplinkModalMetaProvider
     */
    public function __construct(
        RequestInterface $request,
        UrlInterface $urlBuilder,
        DeeplinkModalMetaProvider $deeplinkModalMetaProvider
    ) {
        parent::__construct($request, $urlBuilder);
        $this->deeplinkModalMetaProvider = $deeplinkModalMetaProvider;
    }

    /**
     * ModifyData
     *
     * @param array $data
     * @return array
     */
    public function modifyData(array $data)
    {
        return $data;
    }

   /**
    * ModifyMeta
    *
    * @param array $meta
    * @return array
    */
    public function modifyMeta(array $meta)
    {
        $deeplinkModel = $this->deeplinkModalMetaProvider->getModal();
        $meta['general']['children'][DeeplinkModalMetaProvider::DEFAULT_MODAL_NAME] = $deeplinkModel;
        return $meta;
    }
}
