<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\Mobiapp\Form\Modifier;

class System extends AbstractModifier
{
    public const KEY_SUBMIT_URL = 'submit_url';

    /**
     * @var array
     */
    protected $actionUrls = [
        self::KEY_SUBMIT_URL => 'mobicommerce/mobiapp/save'
    ];

    /**
     * ModifyData data source
     *
     * @param Array $data
     */
    public function modifyData(array $data)
    {
        $actionParameters = [
            'id' => $this->request->getParam('id'),
            'store' => $this->request->getParam('store')
        ];

        $submitUrl = $this->urlBuilder->getUrl($this->actionUrls[self::KEY_SUBMIT_URL], $actionParameters);

        return array_replace_recursive(
            $data,
            [
                'config' => [
                    self::KEY_SUBMIT_URL => $submitUrl
                ]
            ]
        );
    }

    /**
     * ModifyMeta data source
     *
     * @param Array $meta
     */
    public function modifyMeta(array $meta)
    {
        return $meta;
    }
}
