<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\PageBuilder\Form\Modifier;

use Magento\Framework\App\RequestInterface;
use Magento\Framework\UrlInterface;
use Mobicommerce\Mobiapp\Ui\DataProvider\Productcollection\Form\ModalMetaProvider;

class BottomContainerProductCollection extends AbstractModifier
{
    /**
     * BottomContainerProductCollection constructor.
     *
     * @param RequestInterface $request
     * @param UrlInterface $urlBuilder
     * @param ModalMetaProvider $modalMetaProvider
     */
    public function __construct(
        RequestInterface $request,
        UrlInterface $urlBuilder,
        ModalMetaProvider $modalMetaProvider
    ) {
        parent::__construct($request, $urlBuilder);
        $this->modalMetaProvider = $modalMetaProvider;
    }

    /**
     * ModifyData data source
     *
     * @param Array $data
     */
    public function modifyData(array $data)
    {
        return $data;
    }

    /**
     * ModifyMeta data source
     *
     * @param Array $meta
     */
    public function modifyMeta(array $meta)
    {
        $modal = $this->modalMetaProvider->getModal();
        $meta['bottom_container']['children'][ModalMetaProvider::DEFAULT_MODAL_NAME] = $modal;

        return $meta;
    }
}
