<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\Widget\Form\Modifier;

class ImageContainer7 extends AbstractModifier
{
    public const WIDGET_TYPE = '7_image_container';

    /**
     * ModifyData data source
     *
     * @param Array $data
     */
    public function modifyData(array $data)
    {
        $masterData = $data['master_data'];
        if ($masterData['type'] == self::WIDGET_TYPE) {
            $this->bindGenericDefaultData($data);
            $this->bindBannersData($data);
        }
        return $data;
    }

    /**
     * ModifyMeta data source
     *
     * @param Array $meta
     */
    public function modifyMeta(array $meta)
    {
        $widgetType = $this->request->getParam('type', false);
        if ($widgetType == self::WIDGET_TYPE) {
            $meta = $this->modifyBannersMeta(
                $meta,
                'mobicommerce_widget_form_' . self::WIDGET_TYPE
            );
        }
        return $meta;
    }
}
