<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\Widget\Form\Modifier;

use Mobicommerce\Mobiapp\Ui\DataProvider\Deeplink\Form\ModalMetaProvider as DeeplinkModalMetaProvider;

class LinkBuilder extends AbstractModifier
{
    public const WIDGET_TYPE = 'link_builder';

    /**
     * ModifyData data source
     *
     * @param Array $data
     */
    public function modifyData(array $data)
    {
        $masterData = $data['master_data'];
        if ($masterData['type'] == self::WIDGET_TYPE) {
            $this->bindGenericDefaultData($data);

            $id = $this->request->getParam('id');
            $data[$id]['links']['dynamic_rows_links'] = [];

            $table = $this->resourceConnection->getTableName('mobicommerce_widget_link_builder');
            $connection = $this->resourceConnection->getConnection();

            $select = $connection->select()
                ->from(
                    ['links' => $table]
                )->where('widget_id = ?', $id);
            $links = $connection->fetchAll($select);
            if ($links) {
                $data[$id]['links']['dynamic_rows_links']['dynamic_rows_links'] = $links;
            }
        }
        return $data;
    }

    /**
     * ModifyMeta data source
     *
     * @param Array $meta
     */
    public function modifyMeta(array $meta)
    {
        $widgetType = $this->request->getParam('type', false);
        if ($widgetType == self::WIDGET_TYPE) {
            $dynamicRowsHiddenField = $this->deeplinkModalMetaProvider->getDynamicRowsHiddenField();

            $fieldName = DeeplinkModalMetaProvider::DEFAULT_DYNAMIC_ROWS_HIDDEN_FEILD_NAME;
            $meta['links']['children'][$fieldName] = $dynamicRowsHiddenField;
            
            $deeplinkModel = $this->deeplinkModalMetaProvider->getModal(true);
            $meta['links']['children'][DeeplinkModalMetaProvider::DEFAULT_MODAL_NAME] = $deeplinkModel;
        }
        return $meta;
    }
}
