<?php
/**
 * Mobicommerce
 *
 * Copyright (C) 2021 Mobicommerce <info@mobicommerce.net>
 *
 * @category Mobicommerce
 * @package Mobicommerce_Mobiapp
 * @copyright Copyright (c) 2021 Mobicommerce (http://www.mobicommerce.net/)
 * @license http://opensource.org/licenses/gpl-3.0.html GNU General Public License,version 3 (GPL-3.0)
 * @author Mobicommerce <info@mobicommerce.net>
 */

namespace Mobicommerce\Mobiapp\Ui\DataProvider\Widget\Form\Modifier;

class ProductList extends AbstractModifier
{
    public const WIDGET_TYPE = 'product_list';

    /**
     * ModifyData data source
     *
     * @param Array $data
     */
    public function modifyData(array $data)
    {
        $masterData = $data['master_data'];
        if ($masterData['type'] == self::WIDGET_TYPE) {
            $this->bindGenericDefaultData($data);
            $id = $this->request->getParam('id');
            $widgetSpecificOptions = $masterData['widget_specific_options'];
            $widgetSpecificOptions = $this->serialize->unserialize($widgetSpecificOptions);
            $data[$id]['mobicommerce_cms_page']['mobicommerce_cms_page_id'] = $masterData['mobicommerce_cms_page_id'];
        }

        return $data;
    }

    /**
     * ModifyMeta data source
     *
     * @param Array $meta
     */
    public function modifyMeta(array $meta)
    {
        return $meta;
    }
}
