/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

define([
    'underscore',
    'jquery',
    'uiRegistry',
    'Magento_Ui/js/form/element/select'
], function (_, $, uiRegistry, select) {
    'use strict';

    return select.extend({
        initialize: function () {
            this._super();

            this.showHideFields(this.value());

            return this;
        },

        onUpdate: function (value) {
            this.showHideFields(value);

            return this._super();
        },

        showHideFields: function (value) {
            switch (value) {
                case '1':
                    $([
                        'mobicommerce_pwa_landing_page_id',
                        'assign_pagebuilder_button_pwa',
                        'mobicommerce_desktop_landing_page_id',
                        'assign_pagebuilder_button_desktop',
                        'mobicommerce_mobileapp_landing_page_id',
                        'assign_pagebuilder_button_mobileapp'
                    ]).each(function(index, field) {
                        uiRegistry.get("index = " + field).visible(true);
                    });
                    break;

                default:
                    $([
                        'mobicommerce_pwa_landing_page_id',
                        'assign_pagebuilder_button_pwa',
                        'mobicommerce_desktop_landing_page_id',
                        'assign_pagebuilder_button_desktop',
                        'mobicommerce_mobileapp_landing_page_id',
                        'assign_pagebuilder_button_mobileapp'
                    ]).each(function(index, field) {
                        uiRegistry.get("index = " + field).visible(false);
                    });
                    break;
            }
        }
    });
});
