/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

/* global $, $H */

define([
    'jquery',
    'uiRegistry',
    'mage/adminhtml/grid'
], function ($, uiRegistry) {
    'use strict';

    return function (config) {
        var gridJsObject = window[config.gridJsObjectName];

        /**
         * Click on product row
         *
         * @param {Object} grid
         * @param {String} event
         */
        function cmspageRowClick(grid, event) {
            var trElement = Event.findElement(event, 'tr');

            if (trElement) {
                var row = $(trElement).find('td.col-id');
                if (row[0]) {
                    uiRegistry.get("index = deeplink_pagebuilder_value").value($.trim($(row[0]).html()));
                    showDoneButton();
                }
            }
        }

        function showDoneButton() {
            $('.modal-header button.action-primary').removeAttr('disabled');
        }

        gridJsObject.rowClickCallback = cmspageRowClick;
    };
});
