define([
    'underscore',
    'jquery',
    'uiRegistry',
    'Magento_Ui/js/form/element/select'
], function (_, $, uiRegistry, select) {
    'use strict';

    return select.extend({
        initialize: function () {
            var self = this;
            
            this._super();
            
            setTimeout(function(){
                self.showHideFields(self.value());
            }, 800);
            
            return this;
        },

        onUpdate: function (value) {
            this.showHideFields(value);

            return this._super();
        },

        showHideFields: function (value) {
            $('.deeplink_containers').hide();
            uiRegistry.get('index = deeplink_category_value').visible(false);
            uiRegistry.get('index = deeplink_product_value').visible(false);
            uiRegistry.get('index = deeplink_cmspage_value').visible(false);
            uiRegistry.get('index = deeplink_category_force_navigate_to_product_list').visible(false);
            uiRegistry.get('index = deeplink_phone').visible(false);
            uiRegistry.get('index = deeplink_email').visible(false);
            uiRegistry.get('index = deeplink_external_url').visible(false);

            $('.deeplink_container_category').hide();
            $('.deeplink_container_products').hide();
            $('.deeplink_container_cmspage').hide();

            switch (value) {
                case 'category':
                    uiRegistry.get('index = deeplink_category_value').visible(true);
                    uiRegistry.get('index = deeplink_category_force_navigate_to_product_list').visible(true);
                    $('.deeplink_container_category').show();
                    break;
                case 'product':
                    uiRegistry.get('index = deeplink_product_value').visible(true);
                    $('.deeplink_container_products').show();
                    break;
                case 'cms':
                    uiRegistry.get('index = deeplink_cmspage_value').visible(true);
                    $('.deeplink_container_cmspage').show();
                    break;
                case 'phone':
                    uiRegistry.get('index = deeplink_phone').visible(true);
                    break;
                case 'email':
                    uiRegistry.get('index = deeplink_email').visible(true);
                    break;
                case 'external_url':
                    uiRegistry.get('index = deeplink_external_url').visible(true);
                    break;
                default:
                    break;
            }

            this.additionalShowHideFields(value);

            this.showHideDoneButton(value);
        },

        additionalShowHideFields: function(value) {

        },

        showHideDoneButton: function(value) {
            $('.modal-header button.action-primary').removeAttr('disabled');
            return;

            if (value) {
                $('.modal-header button.action-primary').removeAttr('disabled');
            } else {
                $('.modal-header button.action-primary').attr('disabled', true);
            }
        }
    });
});
