/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

define([
        'underscore',
        'jquery',
        'Mobicommerce_Mobiapp/js/deeplink/modal',
        'uiRegistry'
    ],
    function (_, $, Modal, uiRegistry) {
        'use strict';

        return Modal.extend(
            {
                getCurrentDynamicRow: function() {
                    return uiRegistry.get('index = dynamic_rows_links_current_row').value();
                },

                getExistingDeeplinkValue: function() {
                    return uiRegistry.get(this.getCurrentDynamicRow() + '.deeplink').value();
                },

                getDefaultFieldsToHide: function() {
                    var fields = this._super();
                    fields.push('dynamic_rows_links_current_row');
                    return fields;
                },

                bindDeeplinkMainFieldValue: function() {
                    var deeplinkValue = this.getDeeplinkModalSelectedValue(); 
                    uiRegistry.get(this.getCurrentDynamicRow() + '.deeplink').value(deeplinkValue);
                }
            }
        );
    }
);
