/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

define([
        'underscore',
        'jquery',
        'Magento_Ui/js/modal/modal-component',
        'uiRegistry'
    ],
    function (_, $, Modal, uiRegistry) {
        'use strict';

        return Modal.extend(
            {
                /**
                 * Initializes modal on opened function
                 */
                initModal: function () {
                    this.options.opened = this.onOpened.bind(this);
                    this.options.closed = this.onClosed.bind(this);
                    this._super();
                },

                /**
                 * Once the modal is opened it hides the X
                 */
                onOpened: function () {
                    var currentField = uiRegistry.get("index = mobicommerce_button_click_field").value();
                    var value = uiRegistry.get("index = " + currentField).value();
                    uiRegistry.get("index = deeplink_pagebuilder_value").value(value);
                },

                /**
                 * Once the modal is closed it hides the X
                 */
                onClosed: function () {
                },

                actionDone: function() {
                    this.valid = true;
                    this.elems().forEach(this.validate, this);

                    if (this.valid) {
                        this.closeModal();
                        this.bindPageBuilderValue();
                    }
                },

                bindPageBuilderValue: function() {
                    var selectedPageBuilderId = uiRegistry.get("index = deeplink_pagebuilder_value").value();
                    var currentField = uiRegistry.get("index = mobicommerce_button_click_field").value();
                    uiRegistry.get("index = " + currentField).value(selectedPageBuilderId);
                }
            }
        );
    }
);
