/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

/* global $, $H */

define([
    'mage/adminhtml/grid'
], function () {
    'use strict';

    return function (config) {
        var selectedCategories = config.selectedCategories,
            widgetCategories = $H(selectedCategories),
            gridJsObject = window[config.gridJsObjectName],
            tabIndex = 1000;

        $('in_widget_categories').value = Object.toJSON(widgetCategories);

        /**
         * Change banner position
         *
         * @param {String} event
         */
        function positionChange(event) {
            var element = Event.element(event);

            if (element) {
                widgetCategories.set(element.categoryId, element.value);
                $('in_widget_categories').value = Object.toJSON(widgetCategories);
            }
        }

        /**
         * Initialize widget banner row
         *
         * @param {Object} grid
         * @param {String} row
         */
        function widgetCategoryRowInit(grid, row) {
            var categoryId = $(row).getElementsByClassName('col-id')[0].innerText,
                position = $(row).getElementsByClassName('input-text')[0];

            if (position) {
                position.categoryId = categoryId;
                Event.observe(position, 'keyup', positionChange);
            }
        }

        gridJsObject.initRowCallback = widgetCategoryRowInit;

        if (gridJsObject.rows) {
            gridJsObject.rows.each(function (row) {
                widgetCategoryRowInit(gridJsObject, row);
            });
        }
    };
});
