/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

/* global $, $H */

define([
    'jquery',
    'uiRegistry',
    'mage/adminhtml/grid'
], function ($, uiRegistry) {
    'use strict';

    return function (config) {
        var selectedPageId = config.selectedPageId,
            gridJsObject = window[config.gridJsObjectName],
            tabIndex = 1000;

        /**
         * Click on page row
         *
         * @param {Object} grid
         * @param {String} event
         */
        function widgetPageRowClick(grid, event) {
            var trElement = Event.findElement(event, 'tr');
            if (trElement) {
                var row = $(trElement).find('td.col-id');
                if (row[0]) {
                    uiRegistry.get("index = mobicommerce_cms_page_id").value($.trim($(row[0]).html()));
                }
            }
        }

        gridJsObject.rowClickCallback = widgetPageRowClick;
    };
});
