/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

define([
        'underscore',
        'jquery',
        'Magento_Ui/js/modal/modal-component',
        'uiRegistry'
    ],
    function (_, $, Modal, uiRegistry) {
        'use strict';

        return Modal.extend(
            {
                actionDone: function() {
                    this.valid = true;
                    this.elems().forEach(this.validate, this);

                    if (this.valid) {
                        this.closeModal();
                        this.navigateCreateWidgetPage();
                    }
                },

                navigateCreateWidgetPage: function() {
                    var widget_type = uiRegistry.get("index = widget_type").value();
                    var url = $('button#add_new_widget').attr('data-url');
                    url = url.replace('REPLACE_WIDGET_TYPE', widget_type);
                    setLocation(url);
                }
            }
        );
    }
);
