<?php

/**
 * Mobicommerce_RestrictProductTypes
 *
 * @category  PHP
 * @package   Mobicommerce_RestrictProductTypes
 * @author    Mobicommerce <info@mobicommerce.net>
 * @copyright 2022 Copyright (c) Mobicommerce
 * @link      https://www.Mobicommerce.net/
 */

namespace Mobicommerce\RestrictProductTypes\Override\Magento\Catalog\Block\Adminhtml;

class Product extends \Magento\Catalog\Block\Adminhtml\Product
{
    /**
     * Retrieve options for 'Add Product' split button
     *
     * @return array
     */
    protected function _getAddProductButtonOptions()
    {
        $result = [];
        $splitButtonOptions = parent::_getAddProductButtonOptions();

        foreach ($splitButtonOptions as $type => $array) {
            if (in_array($type, ['simple', 'configurable'])) {
                $result[$type] = $array;
            }
        }

        return $result;
    }
}
